.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include tabs.inc

SIZEX STRUCT
	cx_ dd ?
	cy_ dd ?
SIZEX ENDS

WndProcThunk STRUCT BYTE
	m_mov     dd ?
	m_this    dd ?
	m_jmp     db ?
	m_relproc dd ?
WndProcThunk ENDS

HM STRUCT DWORD
	hWnd         dd ? ; unique window handle
	brClose      dd 7     dup (?) ; array of brush handles that draws close button state
	brTab        dd 3     dup (?) ; array of brush handles that draws tab state
	brNav        dd 6     dup (?) ; array of brush handles that draws navigation bar state
	brBk         dd ? ; brush handle that draws control's background
	hfont        dd ? ; font handle that is selected to draw tab's text
	inum         dd ? ; total number of tabs 
	selected     dd ? ; index of selected tab (1-based)
	over         dd ? ; index of tab that is highlighted (1-based)
	close        dd ? 
	navOffs      dd ?
	nav1         dd ?
	nav2         dd ?
	nav_cx       dd ? ; width of one  navigation button  "<-"
	nav_full_cx  dd ? ; width of both navigation buttons "<-->"
	tab_cx       dd ? ; tab width not including close button width
	tab_cy       dd ? ; tab height==background height==close button height
	tab_full_cx  dd ? ; tab width including close button width
	text_pos     dd ? ; vertical text position of each tab
	close_cx     dd ? ; close button width
	tabs_visible dd ? ; number of currently visible tabs
	mdc          dd ? ; off screen dc
	rc           RECT <0,0,0,0>
	dummy_val    dd ? ; needed when index -1 occurs
	tabs         dd 512*2 dup (?) ; structure that contains |DWORD_1-tab text; DWORD_2-tab/close button state
	; DWORD_1 - pointer allocated with HeapAlloc
	; DWORD_2 - 0000YYXX 
	;         where YY-index of close button brush (0-based)
	;         where XX-indes of tab brush (0-based)
HM ENDS


PProc            PROTO :DWORD,:DWORD,:DWORD,:DWORD
DummyProc        PROTO :DWORD,:DWORD,:DWORD,:DWORD
GDTabsProc       PROTO :DWORD,:DWORD,:DWORD,:DWORD
GetBmpBrushArray PROTO :DWORD,:DWORD,:DWORD,:DWORD

.const
	; wParam-0, lParam-{pointer to string}
	GDTM_ADD       equ WM_USER+1300 ; occurs when new tab is added   ; user sends it
	; wParam-{1-based closed tab index}, lParam-0
	GDTM_CLOSED    equ WM_USER+1301 ; occurs when a tab is closed    ; system sends it
	; wParam-{1-based previous active tab index}, lParam-{1-based activated tab index}
	GDTM_ACTIVATED equ WM_USER+1302 ; occurs when a tab is activated ; system sends it
	; wParam-{0-based tab index}, lParam-0
	GDTM_GETTEXT   equ WM_USER+1303 ; occurs when an attempt to get text of particular tab is made ; user sends it
	; wParam-{0-based tab index{, lParam-{pointer to string}
	GDTM_SETTEXT   equ WM_USER+1304 ; occurs when an attempt to set text of particular tab is made ; user sends it
	; wParam-{0-based tab index}, lParam-0
	GDTM_GETACTIVE equ WM_USER+1305 ; occurs when an attempt to retrieve an index of active tab is made ; user sends it
	
.data
	classname db "GDTABS",0
	
	lf LOGFONT <13,8,0,0,400,0,0,0,DEFAULT_CHARSET,0,0,CLEARTYPE_QUALITY,0,"Lucida console">
	t1 db "Tab_1",0
	t2 db "Tab_2",0
	t3 db "Tab_3",0
	tab_num dd 3
.data?
	ALIGN 4
	glob_heap  dd ?
	hInstance  dd ?
	test_con   dd ?
	tabHandles dd 3 dup (?)

.code

start:

	invoke GetModuleHandle, 0
	mov	   hInstance, eax
	invoke GetProcessHeap
	mov    glob_heap, eax
	call   CreateClass
    invoke InitCommonControls
	invoke DialogBoxParam, hInstance, 1000, 0, ADDR DlgProc, 0
	invoke ExitProcess, 0

PProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

	mov    eax, uMsg
	.if eax==WM_INITDIALOG
	.else
		mov		eax, 0
		ret
	.endif
	mov    eax, 1
	ret
PProc endp

DlgProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	LOCAL buf[16]:BYTE
	
	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		invoke CreateWindowEx, 0, ADDR classname, 0, WS_CHILD+WS_VISIBLE, 0,  0, 420, 31, hWin, 0, hInstance, 0
		mov    test_con, eax
		
		invoke CreateDialogParam, hInstance, 2000, hWin, ADDR PProc, 0
		mov    [tabHandles+0], eax
		invoke ShowWindow, eax, SW_HIDE
		invoke CreateDialogParam, hInstance, 3000, hWin, ADDR PProc, 0
		mov    [tabHandles+4], eax
		invoke ShowWindow, eax, SW_HIDE
		invoke CreateDialogParam, hInstance, 4000, hWin, ADDR PProc, 0
		mov    [tabHandles+8], eax
		
		invoke SendMessage, test_con, GDTM_ADD, 0, ADDR t1
		invoke SendMessage, test_con, GDTM_ADD, 0, ADDR t2
		invoke SendMessage, test_con, GDTM_ADD, 0, ADDR t3
		
	.elseif eax==GDTM_CLOSED
		mov    ecx, wParam
		dec    ecx
		invoke DestroyWindow, [tabHandles+ecx*4]
		mov    ecx, tab_num
		sub    ecx, wParam
		shl    ecx, 2
		mov    eax, wParam
		shl    eax, 2
		add    eax, OFFSET tabHandles
		mov    edx, eax
		sub    edx, 4
		invoke RtlMoveMemory, edx, eax, ecx
		dec    tab_num
		mov    eax, tab_num
		mov    [tabHandles+eax*4], 0
		invoke SendMessage, test_con, GDTM_GETACTIVE, 0, 0
		mov    ecx, eax
		jmp    @show
		
	.elseif eax==GDTM_ACTIVATED
		mov    ecx, wParam ; previous active tab
		dec    ecx
		invoke ShowWindow, [tabHandles+ecx*4], SW_HIDE
		mov    ecx, lParam ; current  active tab
		@show:
		dec    ecx
		invoke ShowWindow, [tabHandles+ecx*4], SW_SHOW

	.elseif eax==WM_SIZE
		mov    ecx, lParam
		and    ecx, 0ffffh
		invoke MoveWindow, test_con, 0,  0, ecx, 31, 0
		
	.elseif eax==WM_COMMAND
		invoke SendDlgItemMessage, hWin, 1003, WM_GETTEXT, 10, ADDR buf
		mov    eax, wParam
		.if eax == 1001
			invoke SendMessage, test_con, GDTM_ADD, 0, ADDR buf
			add    tab_num, 1
			
			invoke ShowWindow, [tabHandles+0], SW_HIDE
			invoke ShowWindow, [tabHandles+4], SW_HIDE
			invoke ShowWindow, [tabHandles+8], SW_HIDE
		.endif
		
	.elseif eax==WM_CLOSE
		invoke EndDialog, hWin, 0
		
	.else
		mov		eax, 0
		ret
	.endif
	mov		eax, 1
	ret

DlgProc endp

CreateClass PROC
	LOCAL  wc:WNDCLASSEX

	mov	   wc.cbSize,      SIZEOF WNDCLASSEX
	mov    wc.style,       CS_GLOBALCLASS
	mov	   wc.lpfnWndProc, OFFSET DummyProc
	mov    wc.cbClsExtra,  0
	mov	   wc.cbWndExtra,  0
	push   hInstance
	pop	   wc.hInstance
	mov	   wc.hbrBackground, 0
	mov	   wc.lpszMenuName,  0
	mov	   wc.lpszClassName, OFFSET classname
	mov	   eax, 0
	mov	   wc.hIcon,   eax
	mov	   wc.hIconSm, eax
	invoke LoadCursor, 0, IDC_ARROW
	mov	   wc.hCursor, eax
	invoke RegisterClassEx, ADDR wc
	ret

CreateClass ENDP

DummyProc proc uses esi hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	
	; allocate two structures for saving unique properties
	mov    ecx, sizeof HM            ; control properties
	add    ecx, sizeof WndProcThunk  ; thunk code
	invoke HeapAlloc, glob_heap, 0, ecx
	mov    ecx, hWin
	mov    HM.hWnd[eax], ecx
	mov    esi, eax
	add    esi, sizeof HM
		
	; figure out relative address
	mov    ecx, OFFSET GDTabsProc
	sub    ecx, eax
	sub    ecx, sizeof WndProcThunk
	sub    ecx, sizeof HM
	mov	   DWORD PTR [esi+0], 042444C7h ; sorta trick
	mov	   DWORD PTR [esi+4], eax       ; sorta eax -> this
	mov	   BYTE  PTR [esi+8], 0E9h      ; sorta jmp
	mov	   DWORD PTR [esi+9], ecx       ; sorta relative proc addr
		
	invoke SetWindowLong, hWin, GWL_WNDPROC, esi
	
	; return pProc(hWnd, uMsg, wParam, lParam);
	push   lParam
	push   wParam
	push   uMsg
	push   hWin
	call   esi
	ret
		
DummyProc endp

GDTabsProc proc uses ebx esi edi hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	LOCAL hbmp:DWORD
	LOCAL lenx:DWORD
	LOCAL oldb:DWORD
	LOCAL oldf:DWORD
	LOCAL tem1:DWORD
	LOCAL tem2:DWORD
	LOCAL tem3:DWORD
	LOCAL bmp :DWORD
	LOCAL cnt :DWORD
	LOCAL tmi :TRACKMOUSEEVENT
	LOCAL bm  :BITMAP
	LOCAL dc  :DWORD
	LOCAL ps  :PAINTSTRUCT
	LOCAL pt  :POINT
	LOCAL x   :DWORD
	
	mov    ebx, hWin
	mov    eax, uMsg
	.if eax==WM_CREATE
		xor    eax,      eax
		mov    HM.rc.left[ebx],  eax
		mov    HM.rc.top[ebx],   eax
		mov    HM.inum[ebx],     eax
		mov    HM.selected[ebx],   1
		mov    HM.close[ebx],    eax
		mov    HM.over[ebx],       1
		mov    HM.nav1[ebx],     eax
		mov    HM.nav2[ebx],       1
		mov    HM.navOffs[ebx],  eax
		mov    HM.tabs_visible[ebx], eax
		invoke CreateFontIndirect, ADDR lf
		mov    HM.hfont[ebx], eax
			
		invoke LoadBitmap, hInstance, 13001
		mov    bmp, eax
		invoke GetObject, bmp, sizeof bm, ADDR bm
		mov    eax, bm.bmHeight
		mov    HM.tab_cy[ebx], eax ; get height of tab
		mov    HM.rc.bottom[ebx], eax
		
		invoke CreatePatternBrush, bmp
		mov    HM.brBk[ebx], eax
		invoke DeleteObject, bmp
			
		invoke LoadBitmap, hInstance, 13002
		mov    bmp, eax
		invoke GetBmpBrushArray, HM.hWnd[ebx], bmp, HM.tab_cy[ebx], ADDR HM.brTab[ebx]
		mov    HM.tab_cx[ebx], eax
		mov    HM.tab_full_cx[ebx], eax
		invoke DeleteObject, bmp
			
		invoke LoadBitmap, hInstance, 13003
		mov    bmp, eax
		invoke GetBmpBrushArray, HM.hWnd[ebx], bmp, HM.tab_cy[ebx], ADDR HM.brClose[ebx]
		mov    HM.close_cx[ebx], eax
		add    HM.tab_full_cx[ebx], eax
		invoke DeleteObject, bmp
			
		invoke LoadBitmap, hInstance, 13004
		mov    bmp, eax
		invoke GetBmpBrushArray, HM.hWnd[ebx], bmp, HM.tab_cy[ebx], ADDR HM.brNav[ebx]
		mov    HM.nav_cx[ebx], eax
		add    eax, eax
		mov    HM.nav_full_cx[ebx], eax
		invoke DeleteObject, bmp
			
		invoke GetDC, HM.hWnd[ebx]
		mov    dc, eax
		invoke CreateCompatibleDC, dc
		mov    HM.mdc[ebx], eax
		invoke ReleaseDC, HM.hWnd[ebx], dc
		
	.elseif eax==GDTM_GETTEXT
		mov    ecx, wParam
		mov    eax, [HM.tabs+ecx*8][ebx]
		ret
	
	.elseif eax==GDTM_SETTEXT
		mov    ecx, wParam
		mov    esi, lParam
		mov    edi, [HM.tabs+ecx*8][ebx]
		invoke szLeft, esi, edi, 10
		invoke InvalidateRect, HM.hWnd[ebx], ADDR HM.rc[ebx], 0
		
	.elseif eax==GDTM_GETACTIVE
		mov    eax, HM.selected[ebx]
		ret
			
	.elseif eax==GDTM_ADD
		
		.if HM.inum[ebx] == 512
			ret
		.endif
		mov    eax, HM.inum[ebx]
		mov    esi, [HM.tabs+eax*8][ebx]
		
		cmp    eax, 0
		jz     @F
		;--
		mov    ecx, HM.selected[ebx]
		dec    ecx
		mov    edx, 0600h
		mov    [HM.tabs+ecx*8+4][ebx], edx
		@@:
		
		mov    edx, 0401h
		mov    [HM.tabs+eax*8+4][ebx], edx
			
		mov    eax, HM.rc.right[ebx]
		sub    eax, HM.nav_full_cx[ebx]
		xor    edx, edx
		div    HM.tab_full_cx[ebx]
		cmp    HM.inum[ebx], eax
		jb     @F
		add    HM.navOffs[ebx], 1
		@@:
		
		invoke HeapAlloc, glob_heap, 0, 12
		mov    ecx, HM.inum[ebx]
		mov    [HM.tabs+ecx*8][ebx], eax
		invoke szLeft, lParam, eax, 10
			
		inc    HM.inum[ebx]
		mov    eax, HM.inum[ebx]
		mov    HM.selected[ebx], eax
		mov    eax, HM.rc.right[ebx]
		jmp    @inc_visible_tabs	
		
	.elseif eax==WM_SIZE
		mov    eax, lParam
		mov    ecx, eax
		and    eax, 0ffffh
		shr    ecx, 16
		mov    HM.rc.right[ebx],  eax
	@inc_visible_tabs:
		sub    eax, HM.nav_full_cx[ebx]
		xor    edx, edx
		div    HM.tab_full_cx[ebx]
		test   eax, eax
		jz     @F
		cmp    eax, HM.inum[ebx]
		jbe    @save_number
		mov    eax, HM.inum[ebx]
		@save_number:
		mov    HM.tabs_visible[ebx], eax
		@@:
			
		mov    ecx, HM.inum[ebx]
		sub    ecx, HM.tabs_visible[ebx]
		cmp    HM.navOffs[ebx], ecx
		jbe    @F
		sub    HM.navOffs[ebx], 1
		@@:
			
		invoke GetDC, HM.hWnd[ebx]
		mov    dc, eax
			
		invoke CreateCompatibleBitmap, dc, HM.rc.right[ebx], HM.rc.bottom[ebx]
		mov    hbmp, eax
		invoke SelectObject, HM.mdc[ebx], eax
		invoke DeleteObject, eax
		invoke DeleteObject, hbmp
		invoke ReleaseDC, HM.hWnd[ebx], dc
			
		invoke InvalidateRect, HM.hWnd[ebx], ADDR HM.rc[ebx], 0

	.elseif eax==WM_PAINT
		invoke BeginPaint, HM.hWnd[ebx], ADDR ps
			
		invoke SelectObject, HM.mdc[ebx], HM.hfont[ebx]
		mov    oldf, eax
		invoke SelectObject, HM.mdc[ebx], HM.brBk[ebx]
		mov    oldb, eax
		invoke SetBkMode, HM.mdc[ebx], TRANSPARENT		
			
		xor    eax,  eax
		mov    cnt,  eax
		mov    x,    eax
		mov    esi,  HM.navOffs[ebx]
			
		cmp    HM.tabs_visible[ebx], eax
		jz     @empty
		cmp    HM.inum[ebx], eax
		jz     @empty
		@@:
			
		mov    ecx, [HM.tabs+esi*8+4][ebx]
		mov    edi, ecx
		and    ecx, 0ffh
		mov    ecx, [HM.brTab+ecx*4][ebx]
			
		invoke SelectObject,  HM.mdc[ebx], ecx
		invoke SetBrushOrgEx, HM.mdc[ebx], x, 0, 0		
		invoke PatBlt, HM.mdc[ebx], x, 0, HM.tab_cx[ebx], HM.tab_cy[ebx], PATCOPY
			
		shr    edi, 8
		mov    ecx, [HM.brClose+edi*4][ebx]
		invoke SelectObject, HM.mdc[ebx], ecx
		mov    edi, x
		add    edi, HM.tab_cx[ebx]
		invoke SetBrushOrgEx, HM.mdc[ebx], edi, 0, 0		
		invoke PatBlt, HM.mdc[ebx], edi, 0, HM.close_cx[ebx], HM.tab_cy[ebx], PATCOPY
			
		mov    edi, [HM.tabs+esi*8][ebx]
		invoke szLen, edi
		mov    lenx,  eax
		invoke SetTextColor, HM.mdc[ebx], 0AAAAAAh
		mov    ecx, x
		add    ecx, 9
		invoke TextOut, HM.mdc[ebx], ecx, 11, edi, lenx
		invoke SetTextColor, HM.mdc[ebx], 0000000h
		mov    ecx, x
		add    ecx, 8
		invoke TextOut, HM.mdc[ebx], ecx, 10, edi, lenx
			
		inc    esi
		add    cnt, 1
		mov    eax, HM.tab_full_cx[ebx]
		add    x,   eax
		mov    eax, cnt
		cmp    eax, HM.tabs_visible[ebx]
		jz     @empty
		cmp    esi, HM.inum[ebx]
		jnz    @B
		@empty:
			
		mov    eax, HM.nav1[ebx]
		mov    ecx, [HM.brNav+eax*4][ebx]
		invoke SelectObject,  HM.mdc[ebx], ecx
		invoke SetBrushOrgEx, HM.mdc[ebx], x, 0, 0		
		invoke PatBlt, HM.mdc[ebx], x, 0, HM.nav_cx[ebx], HM.tab_cy[ebx], PATCOPY
		mov    eax, HM.nav_cx[ebx]
		add    x, eax
		mov    eax, HM.nav2[ebx]
		mov    ecx, [HM.brNav+eax*4][ebx]
		invoke SelectObject,  HM.mdc[ebx], ecx
		invoke SetBrushOrgEx, HM.mdc[ebx], x, 0, 0		
		invoke PatBlt, HM.mdc[ebx], x, 0, HM.nav_cx[ebx], HM.tab_cy[ebx], PATCOPY
		mov    eax, HM.nav_cx[ebx]
		add    x, eax
			
		invoke SelectObject,  HM.mdc[ebx], HM.brBk[ebx] ; background 
		invoke SetBrushOrgEx, HM.mdc[ebx], x, 0, 0		
		mov    ecx, HM.rc.right[ebx]
		sub    ecx, x
		invoke PatBlt, HM.mdc[ebx], x, 0, ecx, HM.tab_cy[ebx], PATCOPY
			
		invoke BitBlt, ps.hdc, 0, 0, HM.rc.right[ebx], HM.rc.bottom[ebx], HM.mdc[ebx], 0, 0, SRCCOPY
			
		invoke SelectObject, HM.mdc[ebx], oldb
		invoke SelectObject, HM.mdc[ebx], oldf
		invoke EndPaint, HM.hWnd[ebx], ADDR ps
		
	.elseif eax==WM_MOUSELEAVE
		jmp    @inactive
	.elseif eax==WM_MOUSEMOVE
		mov    tmi.cbSize, sizeof tmi
		mov    eax, HM.hWnd[ebx]
		mov    tmi.hwndTrack, eax
		mov    tmi.dwFlags, TME_LEAVE
		mov    tmi.dwHoverTime, 0
		invoke TrackMouseEvent, ADDR tmi
			
		mov    eax, lParam
		mov    edi, eax
		and    eax, 0ffffh
		mov    esi, eax
		shr    edi, 16
			
		cmp    HM.inum[ebx], 0
		jz     @F
			
		xor    edx, edx
		div    HM.tab_full_cx[ebx]
		inc    eax
			
		mov    tem1, edx
		mov    tem2, eax
			
		xor    ecx, ecx
		.if eax <= HM.inum[ebx] && eax > HM.tabs_visible[ebx]
			mov    ecx, HM.tabs_visible[ebx]
		.endif
			
		.if ecx > 0 && edi < HM.tab_cy[ebx]
			mov    eax, HM.tab_full_cx[ebx]
			mul    ecx
			sub    esi, eax
			.if esi < HM.nav_cx[ebx]
				.if HM.nav1[ebx]==0
					
					mov     ecx, HM.over[ebx]
					.if ecx == HM.selected[ebx]
						mov    edx, 0401h
					.else
						mov    edx, 0600h
					.endif
					dec    ecx
					mov    [HM.tabs+ecx*8+4][ebx], edx
					
					mov    HM.nav1[ebx], 2
					mov    HM.nav2[ebx], 1
					invoke InvalidateRect, HM.hWnd[ebx], ADDR HM.rc[ebx], 0
				.endif
				ret
			.elseif esi > HM.nav_cx[ebx] && esi < HM.nav_full_cx[ebx]
				.if HM.nav2[ebx]==1
					
					mov     ecx, HM.over[ebx]
					.if ecx == HM.selected[ebx]
						mov    edx, 0401h
					.else
						mov    edx, 0600h
					.endif
					dec    ecx
					mov    [HM.tabs+ecx*8+4][ebx], edx
					
					mov    HM.nav1[ebx], 0
					mov    HM.nav2[ebx], 3
					invoke InvalidateRect, HM.hWnd[ebx], ADDR HM.rc[ebx], 0
				.endif
				ret
			.else
				jmp    @inactive
			.endif
			ret
		.endif
			
		mov    esi, tem1
		mov    eax, tem2
		mov    ecx, HM.over[ebx]
			
		add    eax, HM.navOffs[ebx]
			
		.if esi < HM.tab_cx[ebx] && edi < HM.tab_cy[ebx]
			.if eax != HM.over[ebx] || HM.close[ebx] == 1
				mov    HM.close[ebx], 0
				mov    ecx, HM.over[ebx]
				.if ecx == HM.selected[ebx]
					dec    ecx
					mov    [HM.tabs+ecx*8+4][ebx], 0401h ; active + no_close
				.else
					dec    ecx
					mov    [HM.tabs+ecx*8+4][ebx], 0600h ; inactive + no_close
				.endif
				mov    HM.over[ebx], eax
				.if eax != HM.selected[ebx]
					dec    eax
					mov    [HM.tabs+eax*8+4][ebx], 0502h ; selected + no_close
				.endif
				
				invoke InvalidateRect, HM.hWnd[ebx], ADDR HM.rc[ebx], 0				
			.endif
		.elseif edi < HM.tab_cy[ebx] && HM.close[ebx] == 0 || HM.nav1[ebx] > 0
			mov    HM.nav1[ebx],  0
			mov    HM.nav2[ebx],  1
			.if ecx == HM.selected[ebx]
				mov    edx, 0401h ; active + no_close
			.else
				mov    edx, 0600h ; inactive + no_close
			.endif
			dec    ecx
			mov    [HM.tabs+ecx*8+4][ebx], edx
			
			mov    HM.over[ebx], eax
			mov    HM.close[ebx], 1
			.if eax == HM.selected[ebx]
				mov    edx, 0201h ; active + close
			.else
				mov    edx, 0002h ; inactive + close
			.endif
			dec    eax
			mov    [HM.tabs+eax*8+4][ebx], edx
			invoke InvalidateRect, HM.hWnd[ebx], ADDR HM.rc[ebx], 0
		.elseif edi > HM.tab_cy[ebx]
			@inactive:
			mov    ecx, HM.over[ebx]
			mov    eax, HM.nav1[ebx]
			add    eax, HM.nav2[ebx]
			.if ecx != 0 || eax > 1
				mov    HM.close[ebx], 0
				mov    HM.over[ebx],  0
				mov    HM.nav1[ebx],  0
				mov    HM.nav2[ebx],  1
				.if ecx == HM.selected[ebx]
					mov    edx, 0401h
				.else
					mov    edx, 0600h
				.endif
				dec    ecx
				mov    [HM.tabs+ecx*8+4][ebx], edx
				invoke InvalidateRect, HM.hWnd[ebx], ADDR HM.rc[ebx], 0
			.endif
		.endif
			
		@@:
			
	.elseif eax==WM_LBUTTONDOWN || eax==WM_LBUTTONDBLCLK
		mov    eax, lParam
		mov    ecx, eax
		and    eax, 0ffffh
		mov    esi, eax
		shr    ecx, 16
		cmp    ecx, HM.tab_cy[ebx]
		ja     @F
			
		cmp    HM.inum[ebx], 0
		jz     @F
			
		xor    edx, edx
		mov    ecx, HM.tab_full_cx[ebx]
		div    ecx
		inc    eax
			
		.if HM.nav1[ebx]==2
			mov    HM.nav1[ebx], 4
			cmp    HM.navOffs[ebx], 0
			jz     @limit_1
			sub    HM.navOffs[ebx], 1
			@limit_1:
			invoke InvalidateRect, HM.hWnd[ebx], ADDR HM.rc[ebx], 0
			ret
		.elseif HM.nav2[ebx]==3
			mov    HM.nav2[ebx], 5
			mov    eax, HM.navOffs[ebx]
			add    eax, HM.tabs_visible[ebx]
			cmp    eax, HM.inum[ebx]
			jz     @limit_2
			add    HM.navOffs[ebx], 1
			@limit_2:
			invoke InvalidateRect, HM.hWnd[ebx], 0, 0
			ret
		.endif
		mov    tem1, edx
		mov    tem2, eax
			
		mov    eax, HM.tab_full_cx[ebx]
		mul    HM.tabs_visible[ebx]
		cmp    esi, eax
		ja     @F
			
		mov    esi, tem1
		mov    eax, tem2
		mov    ecx, HM.over[ebx]
			
		add    eax, HM.navOffs[ebx]
			
		.if esi > HM.tab_cx[ebx]
			mov    HM.over[ebx], eax
			.if eax == HM.selected[ebx]
				mov    edx, 0301h ; active + close
			.else
				mov    edx, 0102h ; inactive + close
			.endif
			dec    eax
			mov    [HM.tabs+eax*8+4][ebx], edx
			invoke InvalidateRect, HM.hWnd[ebx], ADDR HM.rc[ebx], 0
		.else
			mov    ecx, HM.selected[ebx]
			mov    tem1, ecx
			dec    ecx
			mov    [HM.tabs+ecx*8+4][ebx], 0600h
			
			mov    HM.selected[ebx], eax
			dec    eax
			mov    [HM.tabs+eax*8+4][ebx], 0401h ; active + close
			invoke InvalidateRect, HM.hWnd[ebx], ADDR HM.rc[ebx], 0
			
			invoke GetParent, HM.hWnd[ebx]
			invoke SendMessage, eax, GDTM_ACTIVATED, tem1, HM.selected[ebx]
		.endif
			
		@@:
			
	.elseif eax==WM_LBUTTONUP
		mov    eax, lParam
		mov    ecx, eax
		and    eax, 0ffffh
		mov    esi, eax
		shr    ecx, 16
		cmp    ecx, HM.tab_cy[ebx]
		ja     @no_click
			
		cmp    HM.inum[ebx], 0
		jz     @no_click
			
		xor    edx, edx
		mov    ecx, HM.tab_full_cx[ebx]
		div    ecx
		inc    eax
			
		.if HM.nav1[ebx]==4
			mov    HM.nav1[ebx], 2
			invoke InvalidateRect, HM.hWnd[ebx], ADDR HM.rc[ebx], 0
			ret
		.elseif HM.nav2[ebx]==5
			mov    HM.nav2[ebx], 3
			invoke InvalidateRect, HM.hWnd[ebx], ADDR HM.rc[ebx], 0
			ret
		.endif
			
		mov     tem1, eax
			
		mov     eax, HM.tab_full_cx[ebx]
		mul     HM.tabs_visible[ebx]
		cmp     esi, eax
		ja      @no_click
			
		mov     eax, tem1
			
		add     eax, HM.navOffs[ebx]
			
		mov     tem1, eax
			
		mov    ecx, HM.over[ebx]
		.if HM.close[ebx] == 1
			mov    ecx, HM.selected[ebx]
			mov    tem2, ecx
				
			.if eax < HM.selected[ebx] || eax == HM.selected[ebx] && eax == HM.inum[ebx]
				sub    HM.selected[ebx], 1
			.endif
			mov    ecx, HM.inum[ebx]
			sub    ecx, eax
			shl    ecx, 3
			mov    esi, eax
			shl    esi, 3
			lea    edx, HM.tabs[ebx]
			add    esi, edx
			mov    edi, esi
			sub    edi, 8
			mov    eax, [edi]
			push   eax
			invoke RtlMoveMemory, edi, esi, ecx
			pop    ecx
			invoke HeapFree, glob_heap, 0, ecx
			sub    HM.inum[ebx], 1
			
			mov    eax, HM.inum[ebx]
			.if eax < HM.tabs_visible[ebx]
				mov    HM.tabs_visible[ebx], eax
			.endif
			
			mov    ecx, HM.navOffs[ebx]
			mov    tem3, ecx
			
			cmp    HM.navOffs[ebx], 0
			jz     @F
			sub    HM.navOffs[ebx], 1
			@@:
			
			.if HM.over[ebx] > 1 && tem3 > 0
				sub    HM.over[ebx], 1
			.endif
				
			mov    eax, tem1
			.if eax==tem2
				mov    esi, eax
				sub    esi, tem3
				mov    edi, HM.selected[ebx]
				sub    edi, HM.navOffs[ebx]
				.if edi != esi
					mov    edx, 0401h
				.else
					mov    edx, 0201h
				.endif
				mov    eax, HM.selected[ebx]
				dec    eax
				mov    [HM.tabs+eax*8+4][ebx], edx
			.else
			
				mov    ecx, tem1
				sub    ecx, HM.selected[ebx]
				.if eax==HM.selected[ebx] && tem3==0 || ecx==1 && tem3 > 0
					mov    edx, 0201h
				.else
					mov    edx, 0002h
				.endif
				mov    ecx, 1
				.if tem3 > 0
					inc    ecx
				.endif
				sub    eax, ecx
				mov    [HM.tabs+eax*8+4][ebx], edx
					
			.endif
				
			invoke InvalidateRect, HM.hWnd[ebx], ADDR HM.rc[ebx], 0
			
			invoke GetParent, HM.hWnd[ebx]
			invoke SendMessage, eax, GDTM_CLOSED, tem1, 0
		.endif
		@no_click:
	
	.elseif eax==WM_ERASEBKGND
		mov    eax, 1
		ret
	.elseif eax==WM_DESTROY
		mov    esi, HM.inum[ebx]
		test   esi, esi
		jz     @no_tabs
		@@:
		dec    esi
		mov    ecx, [HM.tabs+esi*8][ebx]
		invoke HeapFree, glob_heap, 0, ecx
		cmp    esi, 0
		jnz    @b
		@no_tabs:
		invoke DeleteObject, HM.hfont[ebx]
		invoke DeleteObject, HM.brBk[ebx]
		invoke DeleteObject, DWORD PTR [HM.brTab  + 0][ebx]
		invoke DeleteObject, DWORD PTR [HM.brTab  + 4][ebx]
		invoke DeleteObject, DWORD PTR [HM.brTab  + 8][ebx]
		invoke DeleteObject, DWORD PTR [HM.brNav  + 0][ebx]
		invoke DeleteObject, DWORD PTR [HM.brNav  + 4][ebx]
		invoke DeleteObject, DWORD PTR [HM.brNav  + 8][ebx]
		invoke DeleteObject, DWORD PTR [HM.brNav  +12][ebx]
		invoke DeleteObject, DWORD PTR [HM.brNav  +16][ebx]
		invoke DeleteObject, DWORD PTR [HM.brNav  +20][ebx]
		invoke DeleteObject, DWORD PTR [HM.brClose+ 0][ebx]
		invoke DeleteObject, DWORD PTR [HM.brClose+ 4][ebx]
		invoke DeleteObject, DWORD PTR [HM.brClose+ 8][ebx]
		invoke DeleteObject, DWORD PTR [HM.brClose+12][ebx]
		invoke DeleteObject, DWORD PTR [HM.brClose+16][ebx]
		invoke DeleteObject, DWORD PTR [HM.brClose+20][ebx]
		invoke DeleteObject, DWORD PTR [HM.brClose+24][ebx]
		invoke DeleteDC, HM.mdc[ebx]
	.elseif eax==WM_NCDESTROY
		invoke HeapFree, glob_heap, 0, ebx
			
	.else
		invoke DefWindowProc, HM.hWnd[ebx], uMsg, wParam, lParam
		ret
	.endif
	
	xor eax, eax
	ret

GDTabsProc endp

GetBmpBrushArray proc uses esi hWin:DWORD, hBmp:DWORD, im_y:DWORD, pBrushes:DWORD
	LOCAL bmp  :BITMAP
	LOCAL dc   :DWORD
	LOCAL bmpX :DWORD
	LOCAL mdcY :DWORD
	LOCAL mdcX :DWORD
	LOCAL bOld :DWORD
	LOCAL bOldX:DWORD
	
	invoke GetDC, hWin
	mov    dc,   eax
		
	invoke GetObject, hBmp, sizeof BITMAP, ADDR bmp
		
	mov    eax, bmp.bmHeight
	xor    edx, edx
	div    im_y
	mov    esi, eax
		
	invoke CreateCompatibleDC, dc
	mov    mdcY, eax
	invoke CreateCompatibleDC, dc
	mov    mdcX, eax
	invoke SelectObject, mdcX, hBmp
	mov    bOldX, eax
		
	test   esi,  esi
	jz     @exit
	;-----
	@@:
	dec    esi
		
	invoke CreateCompatibleBitmap, dc, bmp.bmWidth, im_y
	mov    bmpX, eax
	invoke SelectObject, mdcY, bmpX
	mov    bOld, eax
	mov    eax,  esi
	mul    im_y
	invoke BitBlt, mdcY, 0, 0, bmp.bmWidth, im_y, mdcX, 0, eax, SRCCOPY
	invoke GetCurrentObject, mdcY, OBJ_BITMAP
	mov    edi, eax
	invoke CreatePatternBrush, edi
	mov    ecx,   esi
	shl    ecx,   2
	add    ecx,   pBrushes
	mov    [ecx], eax
	invoke SelectObject, mdcY, bOld
	invoke DeleteObject, edi
	
	test   esi,   esi
	jnz    @B
	@exit:
	;-----
	invoke SelectObject, mdcX, bOldX
	invoke DeleteDC,     mdcX
	invoke DeleteDC,     mdcY
	invoke ReleaseDC,    hWin, dc
	
	mov    eax, bmp.bmWidth
	ret

GetBmpBrushArray endp

end start
